SystemOrganization addCategory: #'Xpf-Multipoint-Plugin'!

SmartSyntaxInterpreterPlugin subclass: #MultiPointerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'mig 6/10/2009 13:48'!
hasHeaderFile

	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^ true! !

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'mig 6/10/2009 13:48'!
requiresPlatformFiles

	"this plugin requires platform specific files in order to work"
	^ true! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'mig 6/10/2009 13:47'!
initialiseModule

	self export: true.
	^ self cCode: 'multiPointerInit()' inSmalltalk: [true]! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'mig 6/10/2009 13:47'!
moduleUnloaded: aModuleName 

	self export: true.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 6/11/2009 17:49'!
primitiveMultiPointerCount

	self primitive: 'primitiveMultiPointerCount'.
	
	^ self multiPointerCount asSmallIntegerObj! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 6/11/2009 18:11'!
primitiveMultiPointerCurrentState: aPointerID with: aMultiPointerState

	|  inputX inputY buttons |
	self primitive: 'primitiveMultiPointerCurrentState'.

	self
		var: #inputX declareC: 'int inputX';
		var: #inputY declareC: 'int inputY';
		var: #buttons declareC: 'int buttons'.

	self cCode: 'multiPointerCurrentState(interpreterProxy->integerValueOf(aPointerID), &inputX, &inputY, &buttons)'.

	interpreterProxy
		storeInteger: 0 ofObject: aMultiPointerState withValue: inputX;
		storeInteger: 1 ofObject: aMultiPointerState withValue: inputY;
		storeInteger: 2 ofObject: aMultiPointerState withValue: buttons.
	
	^ aMultiPointerState! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 6/11/2009 18:12'!
primitiveMultiPointerDeviceSemaphoreHandle: aSemaIndex

	self primitive: 'primitiveMultiPointerDeviceSemaphoreHandle' parameters: #(SmallInteger).
	
	self multiPointerSetDeviceSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 6/11/2009 18:12'!
primitiveMultiPointerEventSemaphoreHandle: aSemaIndex

	self primitive: 'primitiveMultiPointerEventSemaphoreHandle' parameters: #(SmallInteger).
	
	self multiPointerSetEventSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 6/11/2009 18:14'!
primitiveMultiPointerLively: aPointerID

	self primitive: 'primitiveMultiPointerLively'.
	
	^ (self multiPointerLively: (aPointerID asCUnsigned)) asSmallIntegerObj! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 6/11/2009 18:16'!
primitiveMultiPointerName: aPointerID

	| pointerName length buffer |
	self primitive: 'primitiveMultiPointerName'.

	length := self multiPointerNameLength: (interpreterProxy integerValueOf: aPointerID).

	pointerName := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	buffer := interpreterProxy firstIndexableField: pointerName.
	self cCode: 'multiPointerName(interpreterProxy->integerValueOf(aPointerID), length, buffer)'.

	^ pointerName! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 6/10/2009 13:46'!
primitiveMultiPointerUseHardwareMouse

	self primitive: 'primitiveMultiPointerUseHardwareMouse'.
	
	self multiPointerUseHardwareMouse.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 6/10/2009 13:46'!
primitiveMultiPointerUseSoftwareMouse

	self primitive: 'primitiveMultiPointerUseSoftwareMouse'.
	
	self multiPointerUseSoftwareMouse.! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'mig 6/10/2009 13:47'!
shutdownModule

	self export: true.
	^ self cCode: 'multiPointerShutdown()' inSmalltalk: [true]! !
